% NOTE that in octave, matrices are accessed with A(y,x),
% where y is the row and x is the column!

% Suggestion: write a separate octave function file "neighbors.m" 
% that returns an Nx2 vector with the cell coordinates of neighbors of 
% a cell with given coordinates, considering the boundaries of the
% map!
% first line: function n = neighbors(position, dimension)

clear
more off

% load the map
a = load('dijkstra_map_0_5.mat');
map = a.G;

% visualizes the map. Note: 
% the y-axis is inverted, so 0,0 is top-left, 
figure(1)
imshow(map);
title("Occupancy Grid Map")

% retrieve height and width
[h,w] = size(map);

% initialize nodes distance with infinity
distance = ones(h,w)*inf;

% these matrices implicitly store the path
% by containing the x and y position of the previous
% node, respectively. Following these starting at the goal 
% until -1 is reached, returns the computed path, see at the bottom
previous_x = zeros(h,w)-1;
previous_y = zeros(h,w)-1;

% start and goal position (y,x)
start = [34,23];
goal = [16,41];

distance(start(1),start(2)) = 0;

% nodes that have been visited
closed = zeros(h,w);

while sum(!closed(:))>0 % make sure you understand what the
                        % expression after the while does...
  
  % ALL OF YOUR CODE FOR DIJKSTRA'S ALGORITHM GOES HERE!
end

disp "done"

% dim the map so we can see the path
% denoted by cells with value 1
pmap = map*.6; 

% visualization: from the goal to the start,
% set all cells visited by the path to 1
current = [goal(1), goal(2)];
while previous_x(current(1), current(2))>=0
  pmap(current(1), current(2)) = 1;
  cy = previous_y(current(1), current(2));
  cx = previous_x(current(1), current(2));
  current = [cy, cx];
end
figure(2)
imshow(pmap);
title("Planned Path")
